<!doctype html>
<html>
<head>
    <title>iSEC Partners Conducts Tor Browser Hardening Study | The Tor Project</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="monetization" content="$ilp.uphold.com/pYfXb92JBQN4">
    <link rel="stylesheet" href="../static/css/style.css?h=5fc6c25a">
    <link rel="stylesheet" href="../static/fonts/fontawesome/css/all.min.css?h=9d272f6a">
    <link rel="stylesheet" href="../static/pygments.css">
    <link rel="icon" type="image/x-icon" href="../static/images/favicon/favicon.ico">
    <link rel="icon" type="image/png" href="../static/images/favicon/favicon.png">
    <meta property="og:title" content="iSEC Partners Conducts Tor Browser Hardening Study | Tor Project">
    <meta property="og:description" content="In May, the Open Technology Fund commissioned iSEC Partners to study current and future...">
    <meta property="og:image" content="https://blog.torproject.org/static/images/lead.png">
    <meta property="og:url" content="https://blog.torproject.org/isec-partners-conducts-tor-browser-hardening-study/">
    <meta name="twitter:card" content="summary_large_image">
</head>
<body>
  <header>
    <nav>
      <a class="navbar-brand" href="../"><img alt="Tor Blog" src="../static/images/logo.png" /></a>
      <ul class="navbar-nav">
          <li><a href="https://www.torproject.org/about/history/">About</a></li>
          <li><a href="https://support.torproject.org/">Support</a></li>
          <li><a href="https://community.torproject.org/">Community</a></li>
          <li><a href="https://forum.torproject.org/">Forum</a></li>
          <li><a href="https://donate.torproject.org/">Donate</a></li></ul>
    </nav>
  </header>
  <section class="content">
    <main>
  <article class="blog-post">
      <h1 class="title">
        iSEC Partners Conducts Tor Browser Hardening Study
      </h1>
    <p class="meta">by mikeperry | August 18, 2014</p>
    <picture>
      <source media="(min-width:415px)" srcset="../static/images/lead.webp" type="image/webp">
<source srcset="../static/images/lead_small.webp" type="image/webp">

      <img class="lead" src="../static/images/lead.png">
    </picture>
    <div class="body">
      <link rel="stylesheet" href="../static/css/legacy.css?h=21ddbb2d">
      <p>In May, the <a href="https://www.opentechfund.org/" rel="nofollow">Open Technology Fund</a> commissioned <a href="https://www.isecpartners.com/" rel="nofollow">iSEC Partners</a> to study current and future hardening options for the Tor Browser. The Open Technology Fund is the primary funder of Tor Browser development, and it commissions security analysis and review for all of the projects that it funds as a standard practice. We worked with iSEC to define the scope of the engagement to focus on the following six main areas:</p>

<ol>
<li>Review of the current state of hardening in Tor Browser</li>
<li>Investigate additional hardening options and instrumentation</li>
<li>Perform historical vulnerability analysis on Firefox, in order to make informed vulnerability surface reduction recommendations</li>
<li>Investigate image, audio, and video codecs and their respective library's vulnerability history</li>
<li>Review our current about:config settings, both for vulnerability surface reduction and security</li>
<li>Review alternate/obscure protocol and application handlers</li>
</ol>

<p>The <a href="https://github.com/iSECPartners/publications/tree/master/reports/Tor%20Browser%20Bundle" rel="nofollow">complete report</a> is available in the iSEC publications github repo. All tickets related to the report can be found using the <a href="https://trac.torproject.org/projects/tor/query?status=!closed&amp;keywords=~tbb-isec-report" rel="nofollow">tbb-isec-report keyword</a>. General Tor Browser security tickets can be found using the <a href="https://trac.torproject.org/projects/tor/query?status=!closed&amp;keywords=~tbb-security" rel="nofollow">tbb-security keyword</a>.</p>

<h1>Major Findings and Recommendations</h1>

<p>The report had the following high-level findings and recommendations. </p>

<ul>
<li><b>Address Space Layout Randomization is disabled on Windows and Mac</b></li>
<p> Due to our use of cross-compilation and non-standard toolchains in <a href="https://blog.torproject.org/blog/deterministic-builds-part-two-technical-details" rel="nofollow">our reproducible build system</a>, several hardening features have ended up disabled. We have known about the Windows issues prior to this report, and should have a fix for them soon. However, the MacOS issues are news to us, and appear to require that we build 64 bit versions of the Tor Browser for full support. The parent ticket for all basic hardening issues in Tor Browser is <a href="https://trac.torproject.org/projects/tor/ticket/10065" rel="nofollow">bug #10065</a>.</p>
<li><b>Participate in Pwn2Own</b></li>
<p> iSEC recommended that we find a sponsor to fund a <a href="http://www.pwn2own.com/" rel="nofollow">Pwn2Own</a> reward for bugs specific to Tor Browser in a semi-hardened configuration. We are very interested in this idea and would love to talk with anyone willing to sponsor us in this competition, but we're not yet certain that our hardening options will have stabilized with enough lead time for the 2015 contest next March.</p>
<li><b>Test and recommend the Microsoft Enhanced Mitigation Experience Toolkit on Windows</b></li>
<p> The <a href="https://support.microsoft.com/kb/2458544" rel="nofollow">Microsoft Enhanced Mitigation Experience Toolkit</a> is an optional toolkit that Windows users can run to further harden Tor Browser against exploitation. We've created <a href="https://trac.torproject.org/projects/tor/ticket/12820" rel="nofollow">bug #12820</a> for this analysis.</p>
<li><b>Replace the Firefox memory allocator (jemalloc) with ctmalloc/PartitionAlloc</b></li>
<p> PartitionAlloc is a memory allocator designed by Google specifically to mitigate common heap-based vulnerabilities by hardening free lists, creating partitioned allocation regions, and using guard pages to protect metadata and partitions. Its basic hardening features can be picked up by using it as a simple malloc replacement library (as ctmalloc). <a href="https://trac.torproject.org/projects/tor/ticket/10281" rel="nofollow">Bug #10281</a> tracks this work.</p>
<li><b>Make use of advanced ParitionAlloc features and other instrumentation to reduce the risk from use-after-free vulnerabilities</b></li>
<p> The iSEC vulnerability review found that the overwhelming majority of vulnerabilities to date in Firefox were use-after-free, followed closely by general heap corruption. In order to mitigate these vulnerabilities, we would need to make use of the heap partitioning features of PartitionAlloc to actually ensure that allocations are partitioned (for example, by using the existing tags from Firefox's <a href="memory" rel="nofollow">about:memory</a>). We will also investigate enabling assertions in limited areas of the codebase, such as the refcounting system, the JIT and the Javascript engine.
</p></ul>

<h1>Vulnerability Surface Reduction (Security Slider)</h1>

<p>A large portion of the report was also focused on analyzing historical Firefox vulnerability data and other sources of large vulnerability surface for a planned "Security Slider" UI in Tor Browser. </p>

<p>The Security Slider was first suggested by Roger Dingledine as a way to make it easy for users to trade off between functionality and security, gradually disabling features ranked by both vulnerability count and web prevalence/usability impact. </p>

<p>The report makes several recommendations along these lines, but a brief distillation can be found on the <a href="https://trac.torproject.org/projects/tor/ticket/9387#comment:43" rel="nofollow">ticket for the slider</a>.</p>

<p>At a high level, we plan for four levels in this slider. "Low" security will be the current Tor Browser settings, with the addition of JIT support. "Medium-Low" will disable most of the JIT, and make HTML5 media click-to-play via NoScript. "Medium-High" will disable the rest of the JIT, will disable JS on non-HTTPS url bar origins, and disable SVG. "High" will fully disable Javascript, block remote fonts via NoScript, and disable all media codecs except for WebM (which will remain click-to-play).</p>

<p><a rel="nofollow"></a></p>

<h1>The Long Term</h1>

<p>A web browser is a very large and complicated piece of software, and while we believe that the <a href="https://www.torproject.org/projects/torbrowser/design/#privacy" rel="nofollow">privacy properties</a> of Tor Browser are better than those of every other web browser currently available, it is very important to us that we raise the bar to successful code execution and exploitation of Tor Browser as well.</p>

<p>We are very eager to see the deployment of <a href="https://wiki.mozilla.org/Security/Sandbox" rel="nofollow">sandboxing support in Firefox</a>, which should go a long way to improving the security of Tor Browser as well. To improve security for their users, Mozilla has recently shifted <a href="https://groups.google.com/forum/#!searchin/mozilla.dev.platform/e10s/mozilla.dev.platform/q0Ku_8j26Pc/OtHXnNThv0IJ" rel="nofollow">10 engineers</a> into the Electrolysis project, which provides the groundwork for producing a multiprocess sandbox architecture for the desktop Firefox. This will allow them to provide a Google Chrome style security sandbox for website content, to reduce the risk from software vulnerabilities, and generally impede exploitability.</p>

<p>Until that time, we will also be investigating providing <a href="https://trac.torproject.org/projects/tor/ticket/10599" rel="nofollow">hardened builds of Tor Browser</a> using the <a href="https://code.google.com/p/address-sanitizer/wiki/AddressSanitizer" rel="nofollow">AddressSanitizer</a> and <a href="https://gcc.gnu.org/wiki/vtv" rel="nofollow">Virtual Table Verification</a> features of newer GCC releases. While this will not eliminate all vectors of memory corruption-based exploitation (in particular, the hardening properties of AddressSanitizer are not as good as those provided by <a href="www.github.com/santoshn/softboundcets-34/" rel="nofollow">SoftBounds+CETS</a> for example, but that compiler is not yet production-ready), it should raise the bar to exploitation. We are hopeful that these builds in combination with PartitionAlloc and the Security Slider will satisfy the needs of our users who require high security and who are willing to trade performance and usability in order to get it.</p>

<p>We also hope to include optional <a href="https://trac.torproject.org/projects/tor/ticket/5791" rel="nofollow">application-wide sandboxes</a> for Tor Browser as part of the official distribution.</p>

<p><a rel="nofollow"></a></p>

<h1>Why not Google Chrome?</h1>

<p>It is no secret that in many ways, both we and Mozilla are playing catch-up to reach the level of code execution security provided by Google Chrome, and in fact closely following the Google Chrome security team was one of the recommendations of the iSEC report.</p>

<p>In particular, Google Chrome benefits from a <a href="http://www.chromium.org/Home/chromium-security/guts" rel="nofollow">multiprocess sandboxing architecture</a>, as well as several further <a href="http://www.chromium.org/Home/chromium-security/brag-sheet" rel="nofollow">hardening options and innovations</a> (such as PartitionAlloc).</p>

<p>Unfortunately, our budget for the browser project is still very constrained compared to the amount of work that is required to provide the <a href="https://www.torproject.org/projects/torbrowser/design/#privacy" rel="nofollow">privacy properties we feel are important</a>, and Firefox remains a far more cost-effective platform for us for several reasons. In particular, Firefox's flexible extension system, fully scriptable UI, solid proxy support, and its long Extended Support Release cycle all allow us to accomplish far more with fewer resources than we could with any other web browser.</p>

<p>Further, Google Chrome is far less amenable to supporting <a href="https://www.torproject.org/projects/torbrowser/design/#privacy" rel="nofollow">basic web privacy</a> and Tor-critical features (such as solid proxy support) than Mozilla Firefox. <a href="https://blog.torproject.org/blog/google-chrome-incognito-mode-tor-and-fingerprinting" rel="nofollow">Initial efforts</a> to work with the Google Chrome team saw some success in terms of adding APIs that are crucial to addons such as HTTPS-Everywhere, but we ran into several roadblocks when it came to Tor-specific features and changes. In particular, <a href="https://trac.torproject.org/projects/tor/wiki/doc/ImportantGoogleChromeBugs#ProxyBypassBugs" rel="nofollow">several bugs required for basic proxy-safe Tor support</a> for Google Chrome's Incognito Mode ended up blocked for various reasons. </p>

<p>The <a href="https://code.google.com/p/chromium/issues/detail?id=80722" rel="nofollow">worst offender</a> on this front is the use of the Microsoft Windows CryptoAPI for certificate validation, without any alternative. This bug means that certificate revocation checking and intermediate certificate retrieval happen outside of the browser's proxy settings, and is subject to alteration by the OEM and/or the enterprise administrator. Worse, beyond the Tor proxy issues, the use of this OS certificate validation API means that the OEM and enterprise also have a simple entry point for installing their own root certificates to enable transparent HTTPS man-in-the-middle, with full browser validation and no user consent or awareness.</p>

<p>All of this is not to mention the need for defenses against <a href="https://www.torproject.org/projects/torbrowser/design/#identifier-linkability" rel="nofollow">third party tracking</a> and <a href="https://www.torproject.org/projects/torbrowser/design/#fingerprinting-linkability" rel="nofollow">fingerprinting</a> to prevent the linking of Tor activity to non-Tor usage, and which would also be useful for the wider non-Tor userbase.</p>

<p>While we'd love for this situation to change, and are open to working with Google to improve things, at present it means that our only option for Chrome is to maintain an even more invasive fork than our current Firefox patch set, with much less likelihood of a future merge than with Firefox. As a ballpark estimate, maintaining such a fork would require somewhere between 3 and 5 times the engineering staff and infrastructure we currently have at our disposal, in addition to the ramp-up time to port our current feature set over.</p>

<p>Unless either our funding situation or Google's attitude towards the features we require changes, Mozilla Firefox will remain the best platform for us to demonstrate that it is in fact possible to provide <a href="http://www.w3.org/2012/dnt-ws/position-papers/21.pdf" rel="nofollow">true privacy by design</a> for the web for those who want it. It is very distressing that this means playing catch-up and forcing our users to make usability tradeoffs in exchange for improved browser security, but we will continue to do what we can to improve that situation, both with Mozilla and with our own independent efforts.</p>

    </div>
  <div class="categories">
    <ul><li>
        <a href="../category/applications">
          applications
        </a>
      </li></ul>
  </div>
  <div class="comments">
      <h2>Comments</h2>
      <p>Please note that the comment area below has been archived.</p>
      <a id="comment-70871"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-70871" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 18, 2014</p>
    </div>
    <a href="#comment-70871">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-70871" class="permalink" rel="bookmark">Moxilla was not mentioned as</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Moxilla was not mentioned as part of the PRISM system mentioned by N S A whistleblower, Edward Snowden. Google and Microsoft apparently are part of the governmental grid. "Privacy" is much more important than "usability"concerns when using the modern-day internet. Moxilla is efficient enough when considering the alternative PRISM-affiliated Google and Microsoft browsers.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-71199"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71199" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 19, 2014</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-70871" class="permalink" rel="bookmark">Moxilla was not mentioned as</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-71199">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71199" class="permalink" rel="bookmark">I agree. Also there have</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>I agree. Also there have been lots of Sandboxing problems with v8 recently. There is a lot of hype for sandboxing, cause it is a good idea, but you may end up trusting it too much.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-70894"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-70894" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 18, 2014</p>
    </div>
    <a href="#comment-70894">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-70894" class="permalink" rel="bookmark">I just use exclusively</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>I just use exclusively Chrome + Tor every day! Fuck shitfox!!!</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-71285"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71285" class="contextual-region comment js-comment by-node-author" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  mikeperry
  </article>
    <div class="comment-header">
      <p class="comment__submitted">mikeperry said:</p>
      <p class="date-time">August 19, 2014</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-70894" class="permalink" rel="bookmark">I just use exclusively</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-71285">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71285" class="permalink" rel="bookmark">I&#039;d love to see your patches</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>I'd love to see your patches to work around the proxy bypass and privacy issues I linked to in the post!</p>
<p>Otherwise, I'm afraid you're very easy to deanonymize and track.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-71725"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71725" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 21, 2014</p>
    </div>
              <p class="parent visually-hidden">In reply to mikeperry</p>
    <a href="#comment-71725">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71725" class="permalink" rel="bookmark">Simple. Chrome inside a</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Simple. Chrome inside a torified VM.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div></div><a id="comment-70906"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-70906" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 19, 2014</p>
    </div>
    <a href="#comment-70906">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-70906" class="permalink" rel="bookmark">And how about chromium?  </a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>And how about chromium?   Have you look thru what can you do with it?   I know it is different than tor but it is a project called epic privacy browser for example. How about teaming up with Opera they trying to use and extend chrome differently. or it isn't matter which fork you use couse all webkit/blink is limited and you dont have much to do it?<br />
Than why isn't 64bit version for windows?! Do you have to wait while Mozilla officiali support it? (again) I read somewhere x64 browser can add extra security but i dont know is it true or not.  However if its true i think we need to go with it as soon as possible. THANKS FOR YOUR HARD WORK!</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-71331"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71331" class="contextual-region comment js-comment by-node-author" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  mikeperry
  </article>
    <div class="comment-header">
      <p class="comment__submitted">mikeperry said:</p>
      <p class="date-time">August 19, 2014</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-70906" class="permalink" rel="bookmark">And how about chromium?  </a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-71331">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71331" class="permalink" rel="bookmark">We mostly don&#039;t build 64bit</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>We mostly don't build 64bit Windows because Mozilla doesn't. You're right that it would provide better ASLR. It is something we will consider if we manage to get AddressSanitizer and other hardening options working for Windows, but because it is not officially supported by Mozilla, it may end up being a bit of work. </p>
<p>However, in my opinion, a hardened Windows build should be available as 64bit only. Same for Mac and Linux.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-71431"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71431" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 20, 2014</p>
    </div>
              <p class="parent visually-hidden">In reply to mikeperry</p>
    <a href="#comment-71431">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71431" class="permalink" rel="bookmark">Mike--this is off-topic so</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Mike--this is off-topic so feel free to ignore, but do you know *why* Mozilla doesn't do 64-bit builds of Firefox?  I had searched around to find some answers to this in the past, but there seemed to be a real reluctance to accept patches from forks like Waterfox. But it was never clear to me why...</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-71474"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71474" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 20, 2014</p>
    </div>
              <p class="parent visually-hidden">In reply to mikeperry</p>
    <a href="#comment-71474">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71474" class="permalink" rel="bookmark">Two things to consider:
1)</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Two things to consider:<br />
1) 32-bit software can't process snoop or hook into 64-bit software. So malware targeted at 32-bit x86 can't affect the 64-bit process, or at least not without more effort.<br />
2) 64-bit builds of Firefox and Chrome (Chromium) are available but if you read the history of both, you'll find the performance is often worse because the Javascript engines are only optimized to 32-bit levels. Hell you see a lot of these problems show up in the notes for asm.js/emscripten </p>
<p>So if you're trying to use/create a Tor browser on a 64-bit platform, you have to take the performance hits with it. I'd still rather take the performance hits than leave the browser open to tampering.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-71686"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71686" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 21, 2014</p>
    </div>
              <p class="parent visually-hidden">In reply to mikeperry</p>
    <a href="#comment-71686">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71686" class="permalink" rel="bookmark">It`s interesting they not</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>It`s interesting they not supported officially but seems they still making an internal builds!</p>
<p><a href="https://ftp.mozilla.org/pub/mozilla.org/firefox/nightly/latest-mozilla-central/" rel="nofollow">https://ftp.mozilla.org/pub/mozilla.org/firefox/nightly/latest-mozilla-…</a></p>
<p>At the bottom there`s an x64 edition!</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-71482"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71482" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 20, 2014</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-70906" class="permalink" rel="bookmark">And how about chromium?  </a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-71482">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71482" class="permalink" rel="bookmark">When they say Google Chrome,</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>When they say Google Chrome, they're talking about Chromium.  Chrome is Chromium plus some non-free (and closed source) components; as there's no way of telling for sure what any closed-source components are doing, there's a security risk.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-70929"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-70929" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 19, 2014</p>
    </div>
    <a href="#comment-70929">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-70929" class="permalink" rel="bookmark">Thanks for the good</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Thanks for the good work!</p>
<p>Could there be a TBB nightly test to make sure the ASLR is enabled?</p>
<p>I suspect the following Mozilla test does it already:<br />
<a href="https://mxr.mozilla.org/mozilla-central/source/security/sandbox/win/src/process_mitigations_test.cc#43" rel="nofollow">https://mxr.mozilla.org/mozilla-central/source/security/sandbox/win/src…</a> (using WinAPI's <span class="geshifilter"><code class="php geshifilter-php">GetProcessMitigationPolicy</code></span>)</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-70934"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-70934" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 19, 2014</p>
    </div>
    <a href="#comment-70934">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-70934" class="permalink" rel="bookmark">Won&#039;t the security slider</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Won't the security slider fragment the anonymity set and make it more easy to fingerprint users?</p>
<p>The section of the report on the security slider only discusses vulnerability mitigation and doesn't consider the effect on fingerprinting and the anonymity set at all:-(</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-71286"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71286" class="contextual-region comment js-comment by-node-author" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  mikeperry
  </article>
    <div class="comment-header">
      <p class="comment__submitted">mikeperry said:</p>
      <p class="date-time">August 19, 2014</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-70934" class="permalink" rel="bookmark">Won&#039;t the security slider</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-71286">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71286" class="permalink" rel="bookmark">That&#039;s why we only want 3 or</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>That's why we only want 3 or 4 positions on the slider, so that at worst people are fragmented only into those groups. Not ideal, but not terrible, and better than people tweaking all of these options themselves.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-71983"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71983" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 21, 2014</p>
    </div>
              <p class="parent visually-hidden">In reply to mikeperry</p>
    <a href="#comment-71983">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71983" class="permalink" rel="bookmark">There&#039;s been so much</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>There's been so much discussion of "strong crypto" in the media since Snowden.  Between Schneier and other sources who seem to be citing crypto experts, kind of a lot of TorBrowser's default ciphersuites ...seem somewhat vulnerable.  </p>
<p>Might the deactivation of certain ciphersuites (which utilize rc4 and md5, or which do not support forward secrecy), as well as possibly the exclusion of SSL 3.0, be under consideration for inclusion in the Security Slider portion of this new hardening project?</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-71413"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71413" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 20, 2014</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-70934" class="permalink" rel="bookmark">Won&#039;t the security slider</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-71413">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71413" class="permalink" rel="bookmark">&quot;Won&#039;t the security slider</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>"Won't the security slider fragment the anonymity set and make it more easy to fingerprint users?"</p>
<p>Not to suggest that this question is anything less than completely legitimate and valid in its own right but I must take the opportunity to (yet again) apply the very question you ask to something else.</p>
<p>This is the striking discrepancy between the stand-alone Tor Browser (the subject of this thread) and Tails with regard to the AdBlock Plus extension: Tails includes it in their version of Iceweasel (which they now call "Tor Browser"), while stand-alone Tor Browser does not. </p>
<p>This is a striking discrepancy that remains, for years now, while in just about every /other/ area that I am aware of, the trend has been has been in the other direction: to make Tor Browser and Tails' version of Iceweasel as /like/ each other as possible. </p>
<p>Have you ever asked or wondered about /this/ seeming contradiction? </p>
<p>I have, many times now, and have yet to see it addressed. </p>
<p>Shouldn't stand-alone Tor Browser and Tails be uniform in this regard? (I.e., whether an extension such as AdBlock Plus is included or not.)</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-70947"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-70947" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 19, 2014</p>
    </div>
    <a href="#comment-70947">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-70947" class="permalink" rel="bookmark">Mike, I have two questions</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Mike, I have two questions for you:</p>
<p>1. How much money do you need to participate in Pwn20wn? Funding could be realized by crowdfunding (e.g. via Indiegogo).</p>
<p>2. Regarding the "Security Slider", to what extent will this user-specific configuration set affect the anonymity group? Until now, I thought it is crucial that every user appears identical without any distinguishable set-up.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-71287"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71287" class="contextual-region comment js-comment by-node-author" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  mikeperry
  </article>
    <div class="comment-header">
      <p class="comment__submitted">mikeperry said:</p>
      <p class="date-time">August 19, 2014</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-70947" class="permalink" rel="bookmark">Mike, I have two questions</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-71287">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71287" class="permalink" rel="bookmark">1. We&#039;d probably want to run</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>1. We'd probably want to run several prize levels, depending on the hardening configuration. I hear that the largest Pwn2Own prizes reach $50-75k though.. We still need to think about this, and I suspect we won't have a clear idea until after we start to deploy these hardening options.</p>
<p>2. The hope is that with only 3-4 positions, it will not be that much fragmentation. (2 bits of fingerprintable entropy, with one of those positions being harder to fingerprint without JS).</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-70951"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-70951" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 19, 2014</p>
    </div>
    <a href="#comment-70951">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-70951" class="permalink" rel="bookmark">Re: Firefox, A question</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Re: Firefox, A question rather than a comment:<br />
are current releases of the Firefox browser, especially such (modified) builds as used in Tor Browser bundles, still compiled to run on X86-32 processors with SSE but without support for SSE2 (such as AMD "K7" Athlon XP) ?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-70990"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-70990" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 19, 2014</p>
    </div>
    <a href="#comment-70990">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-70990" class="permalink" rel="bookmark">The ultra-fast browsers</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>The ultra-fast browsers QupZilla and Midori are such pretty, nimble little things. What a delight it would be if Tor could be integrated into them.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-71373"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71373" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 20, 2014</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-70990" class="permalink" rel="bookmark">The ultra-fast browsers</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-71373">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71373" class="permalink" rel="bookmark">I second this and have often</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>I second this and have often thought about Midori as a part of a lightweight TBB.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-70997"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-70997" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 19, 2014</p>
    </div>
    <a href="#comment-70997">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-70997" class="permalink" rel="bookmark">Fantastic.  Your commitment</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Fantastic.  Your commitment to transparency, credibility and security is inspiring.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-71135"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71135" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 19, 2014</p>
    </div>
    <a href="#comment-71135">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71135" class="permalink" rel="bookmark">I&#039;m personally disappointed.</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>I'm personally disappointed. Looking at the report, it's almost entirely a bunch of "do more things we consulted with another client about" and fairly obvious improvements...many of which the team has already discussed internally. Little to no new fuzzing, improvements to code coverage, specific unit test guidance, appears to have taken place.</p>
<p>To a trained eye, OTF/Tor Project could've saved a lot of money to hire a few summer students to dig through trac.torproject.org and mozilla's bugzilla. </p>
<p>Mike Perry is an awesome, talented coder and security thinker, but this report basically just captures some of the stuff that's been on his mind ad is in his wake instead of adding to it.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-71433"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71433" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 20, 2014</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-71135" class="permalink" rel="bookmark">I&#039;m personally disappointed.</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-71433">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71433" class="permalink" rel="bookmark">To echo a similar note, the</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>To echo a similar note, the review of about:config settings could have been more useful. On an upstream level, the documentation and expected vs. actual behavior of many relevant about:config settings in stock Firefox remains lousy, even on Bugzilla. There's all kinds of cruft left over from earlier versions as well.</p>
<p>That makes me wonder what else might've been found via fuzzing with a broader scope, casting a wider net, and even just pointing out the need to parse this documentation for Firefox by release version and keep it up-to-date.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-71140"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71140" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 19, 2014</p>
    </div>
    <a href="#comment-71140">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71140" class="permalink" rel="bookmark">when are those tweaks coming</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>when are those tweaks coming to tb?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-71142"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71142" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 19, 2014</p>
    </div>
    <a href="#comment-71142">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71142" class="permalink" rel="bookmark">With regard to funding</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>With regard to funding sources, the German Federal Government has just declared as part of its "digital agenda", that they are willing to fund anonymizing technologies. That sounds crazy in the current era of government surveillance, but hey Mike, that is your chance! Go and call the German Federal Government if they have spare money for the Tor Project.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-71153"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71153" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 19, 2014</p>
    </div>
    <a href="#comment-71153">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71153" class="permalink" rel="bookmark">Thank you Mike and all the</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Thank you Mike and all the Team</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-71170"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71170" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 19, 2014</p>
    </div>
    <a href="#comment-71170">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71170" class="permalink" rel="bookmark">PRISM had nothing to do with</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>PRISM had nothing to do with the browsers. The class of attacks associated with PRISM were network redirection and man-in-the-middle attacks that would impact any browser not using SSL. </p>
<p>Mozilla wasn't mentioned because they don't run a large scale international network, like Google and Microsoft do. In those cases the attacks by the NSA was attacking unencrypted intra-data center email traffic. </p>
<p>To extend this to the browser design is a logical fallacy.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-71484"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71484" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 20, 2014</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-71170" class="permalink" rel="bookmark">PRISM had nothing to do with</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-71484">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71484" class="permalink" rel="bookmark">Yeah, except when Google and</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Yeah, except when Google and Microsoft write their browsers to specifically use services that their networks provide; for instance, sending the text of a webpage you visited to one of their servers to translate it for you because it's in a foreign language, and thereby informing Google of the text of the webpage you're accessing.  Of course,  Firefox does make use of some of Google's services (unfortunately.)</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-71246"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71246" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 19, 2014</p>
    </div>
    <a href="#comment-71246">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71246" class="permalink" rel="bookmark">Hi,
will any of these</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Hi,<br />
will any of these security patches be sent back to stock Firefox?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-71290"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71290" class="contextual-region comment js-comment by-node-author" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  mikeperry
  </article>
    <div class="comment-header">
      <p class="comment__submitted">mikeperry said:</p>
      <p class="date-time">August 19, 2014</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-71246" class="permalink" rel="bookmark">Hi,
will any of these</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-71290">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71290" class="permalink" rel="bookmark">Getting our patches into</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Getting our patches into versions that work for stock Firefox is a little challenging. Mozilla is unwilling to take many of the fingerprinting and tracking defenses as-is, because they are enabled by default.</p>
<p>That said, there is talk that they want to support an "Anonymous Mode" for enhanced private browsing. We intend to augment as many of our patches with prefs and private browsing mode detection in preparation for this idea. We expect to have another merge push shortly after we finish the switch to Firefox 31ESR.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-71430"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71430" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 20, 2014</p>
    </div>
              <p class="parent visually-hidden">In reply to mikeperry</p>
    <a href="#comment-71430">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71430" class="permalink" rel="bookmark">Just so Mike doesn&#039;t have to</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Just so Mike doesn't have to address this, I wanted to point out that whatever technical/practical issues there may be with upstreaming TBB code to Mozilla, the reason this isn't happening is that Mozilla is heavily dependent on Google for funding and as a result, hesitant to do anything that undermines Google's ability to track Firefox users out of the box.  </p>
<p>That's one of the reasons we've seen the farce of Firefox trying to have its cake and eat it too with things like "Committed to you, your privacy, and an open web!" on their front page....which also serves Google Analytics if you leave js enabled.</p>
<p>There are great people working on Firefox at Mozilla, but they need more financial and other support from people like us so that their privacy features aren't always informally up for review in terms of Google's ability to track users for advertising.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div></div><a id="comment-71273"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71273" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 19, 2014</p>
    </div>
    <a href="#comment-71273">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71273" class="permalink" rel="bookmark">Wait a minute, am I</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Wait a minute, am I misunderstanding, or just plain naive?</p>
<p>"Google Chrome"</p>
<p>Do you actually mean "Chromium"? Because you obviously are aware of Google Chrome's mother, and what it is.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-71367"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71367" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 20, 2014</p>
    </div>
    <a href="#comment-71367">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71367" class="permalink" rel="bookmark">[NOTE: Although currently</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>[NOTE: Although currently appearing in the comments for the "How to use the “meek” pluggable transport" entry, I had intended to post the following *here* ("iSEC Partners Conducts Tor Browser Hardening Study"). My apologies for the resulting cross-post.] </p>
<p> RESTRICTING IMAGES TO DECREASE ATTACK SURFACE</p>
<p>I recall at least one post from some time back in which one of the Tor devs (either arma or Mike Perry, IIRC) pointed-out that image-rendering in any browser presents a major vector for attack.</p>
<p>So, in the meantime, for those who can get-by without them, wouldn't blocking all or at least third-party images from loading greatly decrease the attack surface within TBB?</p>
<p>For those wishing to try this, here are instructions: (Omit the quotation marks when entering the phrases below)</p>
<p>1.) Type "about:config"into the URL bar, then hit 'enter' (A warning will appear that you will need to accept before you can proceed.)</p>
<p>A search-bar should appear on top of the page, just under the URL bar.</p>
<p>2.) Enter "permissions.default.image" into said search-bar.</p>
<p>The default setting, "1": enable all images, should appear.<br />
To change this:</p>
<p>3.) click to highlight, "permissions.default.image", the string-of-text that should appear just below "Preference Name"<br />
(which, in turn, appears just under the search-bar)</p>
<p>4.) Now, either double-click the highlighted string or right-click and select "Modify"</p>
<p>5.) Change to either "2" (do not load any images), or "3" (do not load third-party images)</p>
<p>Note 1: Even "2" does not block /all/ images for me; a number of clickable images that are actually links still appear. Example: news.google.com</p>
<p>Note 2: When viewing this site, blog.torproject.org, with images disabled, links become camouflaged by the green background color of the page. The workaround is to highlight those areas where a link appears to be missing. This should make it visible.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-71426"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71426" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 20, 2014</p>
    </div>
    <a href="#comment-71426">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71426" class="permalink" rel="bookmark">I would definitely like to</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>I would definitely like to see more focus on hardening for Linux as well. Apparmor and SELinux should cover the bases for most distros, especially the biggest several (Debian, Ubuntu, Fedora, etc.). And Apparmor at least should be relatively straightforward to make portable since Tor Browser runs mostly (but not entirely) in its own directory. </p>
<p>I will check the bug tracker to see if there is a ticket and make a feature request, and of course volunteer to help do what I can. Thanks for all that you guys and gals do.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-71512"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71512" class="contextual-region comment js-comment by-node-author" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  mikeperry
  </article>
    <div class="comment-header">
      <p class="comment__submitted">mikeperry said:</p>
      <p class="date-time">August 20, 2014</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-71426" class="permalink" rel="bookmark">I would definitely like to</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-71512">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71512" class="permalink" rel="bookmark">Yes, after posting I</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Yes, after posting I realized I forgot to mention this. The ticket is <a href="https://trac.torproject.org/projects/tor/ticket/5791" rel="nofollow">https://trac.torproject.org/projects/tor/ticket/5791</a>. There are some experimental AppArmor and Seatbelt profiles already.</p>
<p>We hope to add them as an optional item in the official bundles, but the Linux sandboxes in particular require root and often cause evidence of vioations and the policy itself to exist outside of the Tor Browser directory, hence those sandboxes will be optional.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-71949"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-71949" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 21, 2014</p>
    </div>
    <a href="#comment-71949">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-71949" class="permalink" rel="bookmark">Why are dom.storage.enabled</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Why are dom.storage.enabled and device.sensors.enabled set to true?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-73289"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-73289" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 22, 2014</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-71949" class="permalink" rel="bookmark">Why are dom.storage.enabled</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-73289">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-73289" class="permalink" rel="bookmark">also wondering this...</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>also wondering this... they're among the settings i change in TBB</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-73623"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-73623" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">August 22, 2014</p>
    </div>
    <a href="#comment-73623">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-73623" class="permalink" rel="bookmark">&quot;Note 1: Even &quot;2&quot; does not</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>"Note 1: Even "2" does not block /all/ images for me; a number of clickable images that are actually links still appear. Example: news.google.com"</p>
<p>Its embedded image code.If you want look into 'Page source' and create special ADB rule(-:.</p>
</div>
  </div>
</article>
<!-- Comment END -->
  </div>
  </article>

</main>
    <aside class="sidebar">
<!-- ##SIDEBAR## -->
</aside>
  </section>
  <footer><div class="row download">
    <div class="col circles"></div>
    <div class="col link">
        <h3>Download Tor Browser</h3>
        <p>Download Tor Browser to experience real private browsing without tracking, surveillance, or censorship.</p>
        <a class="btn" href="https://www.torproject.org/download/">Download Tor Browser <i class="fas fa-arrow-down-png-purple"></i></a>
    </div>
</div>
<div class="row social">
    <div class="col newsletter">
        <h3>Subscribe to our Newsletter</h3>
        <p>Get monthly updates and opportunities from the Tor Project:</p>
        <p class="w"><a class="btn btn-dark" role="button" href="https://newsletter.torproject.org/">Sign up</a></p>
    </div>
    <div class="col links">
        <div class="row">
            <h4><a target="_blank" href="https://www.facebook.com/TorProject/"><i class="fab fa-facebook"></i></a></h4>
            <h4><a target="_blank" href="https://mastodon.social/@torproject" rel="me"><i class="fab fa-mastodon"></i></a></h4>
            <h4><a target="_blank" href="https://twitter.com/torproject"><i class="fab fa-twitter"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://www.instagram.com/torproject"><i class="fab fa-instagram"></i></a></h4>
            <h4><a target="_blank" href="https://www.linkedin.com/company/tor-project"><i class="fab fa-linkedin"></i></a></h4>
            <h4><a target="_blank" href="https://github.com/torproject"><i class="fab fa-github"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://t.me/torproject"><i class="fab fa-telegram"></i></a></h4>
        </div>
    </div>
</div>
<div class="row notice">
    <p>Trademark, copyright notices, and rules for use by third parties can be found in our <a href="https://www.torproject.org/about/trademark/">FAQ</a>.</p>
</div></footer>
</body>
</html>
